/***************************************************************************\
 * ChapterXtractor by Christophe.Paris@free.fr                             *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <vector.h>

#include <math.h>
#include "vStrip/parse_ifo.h"

//---------------------------------------------------------------------------
#include <Buttons.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

extern int AppliResult;

class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TOpenDialog *OpenDialog1;
	TPageControl *PageControl1;
	TTabSheet *tabRAWData;
	TTabSheet *tabCustomize;
	TListView *lstCells;
	TPanel *Panel2;
	TSpeedButton *bttOpenIFO;
	TLabel *Label1;
	TSpeedButton *bttQuit;
	TSpeedButton *bttHelpAbout;
	TLabel *Label2;
	TSpeedButton *bttOpenAVI;
	TLabel *Label3;
	TEdit *edFrameOff;
	TEdit *edAVIFileName;
	TComboBox *cbFrameRate;
	TCheckBox *cbSynchKF;
	TComboBox *cbTitle;
	TPopupMenu *pmLstCells;
	TMenuItem *Useintimestamp1;
	TMenuItem *Dontuseintimestamp1;
	TCheckBox *chkFixLCB;
	TTabSheet *tsReadme;
	TMemo *ReadmeMemo;
	TRichEdit *Memo1;
	TMenuItem *Uncheck1;
	TMenuItem *N1;
	TMenuItem *Check1;
	TEdit *edMsOff;
	TTabSheet *tsFormat;
	TPanel *Panel3;
	TMemo *CustomMemo;
	TComboBox *cbPresets;
	TEdit *edFormat;
	TLabel *Label6;
	TLabel *Label7;
	TSpeedButton *bttModifPresetName;
	TSpeedButton *bttSavePresetFormat;
	TPanel *Panel4;
	TPanel *Panel1;
	TLabel *Label4;
	TLabel *lbLstTimeLen;
	TLabel *Label5;
	TLabel *lbLstNbsChapter;
  TSpeedButton *bttSaveData;
  TSaveDialog *SaveDialog1;
  TLabel *Label8;
  TEdit *edHeader;
  TLabel *Label9;
  TEdit *edFooter;
  TLabel *Label10;
  TEdit *edFormatFileName;
  TSpeedButton *bttBrowseFilename;
  TLabel *Label11;
  TEdit *edFormatDirectory;
  TSpeedButton *bttBrowseDir;
  TSpeedButton *bttGO;
	void __fastcall bttOpenIFOClick(TObject *Sender);
	void __fastcall bttQuitClick(TObject *Sender);
	void __fastcall edFrameOffExit(TObject *Sender);
	void __fastcall bttHelpAboutClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall cbFrameRateExit(TObject *Sender);
	void __fastcall bttOpenAVIClick(TObject *Sender);
	void __fastcall cbTitleChange(TObject *Sender);
	void __fastcall lstCellsMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall lstCellsCustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
	void __fastcall Useintimestamp1Click(TObject *Sender);
	void __fastcall Dontuseintimestamp1Click(TObject *Sender);
	void __fastcall PageControl1Change(TObject *Sender);
	void __fastcall cbFrameRateChange(TObject *Sender);
	void __fastcall edFrameOffKeyPress(TObject *Sender, char &Key);
	void __fastcall pmLstCellsPopup(TObject *Sender);
	void __fastcall Uncheck1Click(TObject *Sender);
	void __fastcall Check1Click(TObject *Sender);
	void __fastcall cbSynchKFClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall bttModifPresetNameClick(TObject *Sender);
	void __fastcall cbPresetsKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall bttSavePresetFormatClick(TObject *Sender);
	void __fastcall cbPresetsChange(TObject *Sender);
  void __fastcall bttSaveDataClick(TObject *Sender);
  void __fastcall bttBrowseFilenameClick(TObject *Sender);
  void __fastcall bttBrowseDirClick(TObject *Sender);
  void __fastcall bttGOClick(TObject *Sender);
private:	// User declarations
	ifo_t *ifo;
	int fd;

	vector<unsigned int> cellCumulTime;
	vector<unsigned int> cellTime;
	vector<unsigned int> cellLinks;

	unsigned int nbsChapters;
	unsigned int frameRate;

	void __fastcall PrintVideoInfo();
	AnsiString ifoFileName;
  AnsiString aviFileName;
  AnsiString FormatFileName;
	AnsiString AppsPath;

	TStringList* PresetsFormat;
	TStringList* HeadersFormat;
	TStringList* FootersFormat;



	void __fastcall parseIfo(bool autoSelectPGCI);
	void __fastcall RecalculateTSFromLst();
	void __fastcall CalculateCustomChapters();	
	void __fastcall AddDecoratedLine(AnsiString text, TFontStyle fs);
	void __fastcall AddDecoratedLine2(AnsiString text);
	void __fastcall ChangeSelected(AnsiString s, bool checked);
	void __fastcall UpdateCurrentPage();
	void __fastcall UpdateListLinkAndChapters();
	void __fastcall LoadPresets();
	void __fastcall SavePresets();
	int __fastcall SearchLongestTitle();	
public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
